#!/usr/bin/perl -w
package core::help;

use strict;
use warnings;

# Description: Displays the usage for the perl migration utility
# Params: NA
# Return: NA or die on failure
sub printhelp
{
    my $diemsg = sprintf("\nTo convert teradata database perl scripts to FusionInsight LibrA
perl sqlTDtoGS.pl inputpath|-i=inputpath [-d=bteq] [-s=sql_lang] [-m=dscpath] [-a] [-r] [-v] [-e] [-f=encoding-format] [-t=overwrite|cancel] [-g=targetdb] [-o=outputpath]

    -i | --input-folder
    The input/source folder that contains the Teradata perl scripts to be converted.

    -d | --db-bteq-tag-name
    The db-bteq-tag which must be converted.

	-s | --db-tdsql-tag-name
    The db-tdsql-tag which must be converted.
    
    -m | --dsc-path
    The dsc path where DSC package is available.

    -a | --add-timing-on
    Add timing for bteq scripts and execute.

    -r | --remove-intermediate-files
    Remove the intermediate files that are generated during dsc.

    -v | --migrate-variables
    Migrate the prepare variables contents.
 
    -e | --migrate-executequery
    Migrate the sql contents of execute_query.

    -f | --encoding-format
    The encoding format that must be used for converting the files.
    
    -t | --target_files
    Specifies if target files must be overwritten or cancel the operation if content exist or delete the folder.
    
    -g | --target_db
    Specifies if the target database is gauss100 or gauss200.

    -o | --output-folder
    The output/target folder where the converted scripts are placed.

    -l | --log-folder
    The log file path where the log files are created.
    
    -c | --thread-count
    Specifies the count of the threads.
    
To display Perl DSC version details
perl sqlTDtoGs.pl -V | --version

To display Perl DSC help details
perl sqlTDtoGs.pl -H | --help

Refer the user manual for more details.\n\n");
    die($diemsg);
}

return 1;
