import Queue
import logging
import os
from commands import getstatusoutput

from threading import Thread

from shell_utils import setquerycount, getqueycount
from run_utils import rungauss200scriptfile, rungauss100scriptfile_file

threadcountA = 10
threadcountT = 1


class ImportDDLToGauss(Thread):

    def __init__(self, queue, configdata, homepath, outputfolder):
        Thread.__init__(self)
        self.queue = queue
        self.configdata = configdata
        self.homepath = homepath
        self.outputfolder = outputfolder

    def run(self):
        dbtype = self.configdata['gaussdb-type']
        username = self.configdata['gaussdb-user']
        password = self.configdata['gaussdb-password']
        port = self.configdata['gaussdb-port']
        successoutputfile = os.path.join(self.homepath, 'log', 'gaussexecutionlog.log')
        errorlogfile = os.path.join(self.homepath, 'log', 'gaussexecutionerror.log')
        outputfolderfile = self.outputfolder

        ip = self.configdata['gaussdb-ip']
        if dbtype == "gaussdbt":
            while True:
                filename = self.queue.get()
                if filename is None:
                    return
                with open(filename, 'r') as fl:
                    try:
                        lines = fl.readlines()
                        # length = len(lines)
                        mapfilename = os.path.join(outputfolderfile, 'rangeMapper',
                                 filename.split(outputfolderfile)[1].split('output', 1)[1].replace('/', '', 1))
                        with open(mapfilename, 'r') as mpfl:
                            tempfile =mapfilename + ".txt"
                            if os.path.exists(tempfile):
                                cmd = "rm {0} ".format(tempfile)
                                getstatusoutput(cmd)
                            if not os.path.exists(tempfile):
                                cmd = "touch {0} ".format(tempfile)
                                getstatusoutput(cmd)

                            maplines = mpfl.readlines()
                            flag = True
                            for mline in maplines:
                                string = ""
                                if len(mline) > 3:
                                    mline = mline.replace("\n", "")
                                    mlinelist = mline.split(",")
                                    list = lines[int(mlinelist[0])-1:int(mlinelist[1])]
                                    string = string.join(list)
                                    tpfile = open(tempfile, "a")
                                    tpfile.writelines(string)
                                    tpfile.close()

                                    rungauss100scriptfile_file(ip, port, username, password, tempfile,
                                                               successoutputfile, errorlogfile, filename,
                                                               int(mlinelist[0]), flag)
                                    flag = False
                                    tempfilename = open(tempfile, "a")
                                    tempfilename.truncate(0)
                                    tempfilename.close()

                            mpfl.close()
                        setquerycount(getqueycount() + 1)
                    except (IOError, OSError, Exception) as error:
                        setquerycount(getqueycount() + 1)
                        #print error
                        logging.error("Exception occured during query execution to gaussdb {0}".format(error))

                    finally:
                        fl.close()

        else:
            dbname = self.configdata['gaussdb-name']
            while True:
                filename = self.queue.get()
                if filename is None:
                    return
                try:
                    rungauss200scriptfile(dbname, port, username, password, ip, filename, successoutputfile,
                                          errorlogfile)
                except (IOError, OSError, Exception) as error:
                    logging.error("Exception occured during query execution to gaussdb {0}".
                                  format(error))


def gaussDDLTask(folder_path, configdata, homepath, outputfolder):
    queue = Queue.Queue()
    dbtype = configdata['gaussdb-type']
    if dbtype == 'gaussdba':
        for x in range(threadcountA):
            thread = ImportDDLToGauss(queue, configdata, homepath, outputfolder)
            thread.daemon = True
            thread.start()
        for fle in sorted(folder_path[2], key=str.lower):
            filename = os.path.join(folder_path[0], fle)
            queue.put((filename))
        for x in range(threadcountA):
            queue.put(None)
    else:
        for x in range(threadcountT):
            thread = ImportDDLToGauss(queue, configdata, homepath, outputfolder)
            thread.daemon = True
            thread.start()
        for fle in sorted(folder_path[2], key=str.lower):
            filename = os.path.join(folder_path[0], fle)
            #print filename
            queue.put((filename))
        for x in range(threadcountT):
            queue.put(None)

