import csv
import logging
import os
import re
from commands import getstatusoutput

#from shell_utils import totaldbtquery, faileddbtquery
from shell_utils import totalDBTquery, failedDBTquery

totaltypecountmap = dict()
successtypecountmap = dict()
createtable = "CREATE TABLE"
altertable = "ALTER TABLE"
createtype = "CREATE TYPE"
altertype = "ALTER TYPE"
createindex = "CREATE INDEX"
alterindex = "ALTER INDEX"
createsequence = "CREATE SEQUENCE"
altersequence = "ALTER SEQUENCE"
createsession = "CREATE SESSION"
altersession = "ALTER SESSION"
createsynonym = "CREATE SYNONYM"
altersynonym = "ALTER SYNONYM"
createview = "CREATE VIEW"
alterview = "ALTER VIEW"
createfunction = "CREATE FUNCTION"
createprocedure = "CREATE PROCEDURE"
createpackage = "CREATE PACKAGE"
anonymousblock = "ANONYMOUS BLOCK"


def gettotalquerystatusbulk(outputfol):
    totalqueryfindpattern = re.compile(
        r'(?i)^\s*(?:CREATE|ALTER)\s+(.*?)?(?<!\w)(TYPE|TABLE|INDEX|SEQUENCE|SESSION|VIEW|SYNONYM)')

    filename = os.path.join(outputfol, 'output')
    create_table = 0
    alter_table = 0
    create_type = 0
    alter_type = 0
    create_index = 0
    alter_index = 0
    create_sequence = 0
    alter_sequence = 0
    create_session = 0
    alter_session = 0
    create_synonym = 0
    alter_synonym = 0
    create_view = 0
    alter_view = 0
    comment_count = 0
    insert_count = 0
    delete_count = 0
    update_count = 0
    truncate_count = 0
    for dirs_file_name in os.walk(filename):
        for fle in dirs_file_name[2]:

            with open(os.path.join(dirs_file_name[0], fle), 'r') as fl:
                lines = fl.readlines()

                length = len(lines)
                for index in range(length):

                    createaltermatch = re.match("(?i)^create|alter", lines[index].strip())
                    query = None
                    if createaltermatch:
                        if index < length - 1:
                            query = totalqueryfindpattern.match(lines[index] + lines[index + 1])
                    if query:
                        matcherStr = query.group().upper().strip()
                        if "TABLE" in matcherStr:
                            if matcherStr.startswith("CREATE"):
                                create_table = create_table + 1
                                totaltypecountmap[createtable] = create_table
                            else:
                                alter_table = alter_table + 1
                                totaltypecountmap[altertable] = alter_table
                        elif "TYPE" in matcherStr:
                            if matcherStr.startswith("CREATE"):
                                create_type = create_type + 1
                                totaltypecountmap[createtype] = create_type
                            else:
                                alter_type = alter_type + 1
                                totaltypecountmap[altertype] = alter_type
                        elif "INDEX" in matcherStr:
                            if matcherStr.startswith("CREATE"):
                                create_index = create_index + 1

                                totaltypecountmap[createindex] = create_index
                            else:
                                alter_index = alter_index + 1
                                totaltypecountmap[alterindex] = alter_index
                        elif "SEQUENCE" in matcherStr:
                            if matcherStr.startswith("CREATE"):
                                create_sequence = create_sequence + 1
                                totaltypecountmap[createsequence] = create_sequence
                            else:
                                alter_sequence = alter_sequence + 1
                                totaltypecountmap[altersequence] = alter_sequence
                        elif "SESSION" in matcherStr:
                            if matcherStr.startswith("CREATE"):
                                create_session = create_session + 1
                                totaltypecountmap[createsession] = create_session
                            else:
                                alter_session = alter_session + 1
                                totaltypecountmap[altersession] = alter_session
                        elif "SYNONYM" in matcherStr:
                            if matcherStr.startswith("CREATE"):
                                create_synonym = create_synonym + 1
                                totaltypecountmap[createsynonym] = create_synonym
                            else:
                                alter_synonym = alter_synonym + 1
                                totaltypecountmap[altersynonym] = alter_synonym
                        else:
                            if "VIEW" in matcherStr:
                                if matcherStr.startswith("CREATE"):
                                    create_view = create_view + 1
                                    totaltypecountmap[createview] = create_view
                                else:
                                    alter_view = alter_view + 1
                                    totaltypecountmap[alterview] = alter_view
                    else:

                        string = lines[index].upper().strip()
                        if "COMMENT" in string:
                            if index < length - 1:

                                string = (string + lines[index + 1]).strip().upper()

                                commmentmatch = re.match("(?i)^\s*(comment\s+)(.*)", string)
                                if commmentmatch:
                                    comment_count = comment_count + 1
                                    totaltypecountmap["COMMENT"] = comment_count
                        elif "INSERT" in string:
                            insertmatch = re.match("(?i)^\s*(insert\s*)(.*)", string)
                            if insertmatch:
                                insert_count = insert_count + 1
                                totaltypecountmap["INSERT"] = insert_count

                        elif "DELETE" in string:
                            insertmatch = re.match("(?i)^\s*(delete\s*)(.*)", string)
                            if insertmatch:
                                delete_count = delete_count + 1
                                totaltypecountmap["DELETE"] = delete_count

                        elif "UPDATE" in string:
                            insertmatch = re.match("(?i)^\s*(update\s*)(.*)", string)
                            if insertmatch:
                                update_count = update_count + 1
                                totaltypecountmap["UPDATE"] = update_count
                        elif "TRUNCATE" in string:
                            insertmatch = re.match("(?i)^\s*(truncate\s*)(.*)", string)
                            if insertmatch:
                                truncate_count = truncate_count + 1
                                totaltypecountmap["TRUNCATE"] = truncate_count

                fl.close()


def gettotalquerystatusblogic(outputfol):
    totalqueryfindpattern = re.compile(
        r'(?i)^(?:create\s+)(?:.*?)(?:package|procedure|function)')

    filename = os.path.join(outputfol, 'output')
    create_function = 0
    create_procedure = 0
    create_package = 0
    anonymous_block = 0

    for dirs_file_name in os.walk(filename):
        for fle in dirs_file_name[2]:

            with open(os.path.join(dirs_file_name[0], fle), 'r') as fl:
                lines = fl.readlines()

                for line in lines:
                    query = totalqueryfindpattern.match(line)
                    if query:
                        matcherStr = query.group().upper().strip()
                        if "FUNCTION" in matcherStr:
                            create_function = create_function + 1
                            totaltypecountmap[createfunction] = create_function
                        elif "PROCEDURE" in matcherStr:
                            create_procedure = create_procedure + 1
                            totaltypecountmap[createprocedure] = create_procedure
                        else:
                            create_package = create_package + 1
                            totaltypecountmap[createpackage] = create_package
                    else:
                        string = line.upper()
                        if "ANONYMOUSBLOCK" in string:
                            blockmatch = re.match("(?i)^\s*(\/\*~#~AnonymousBlock~#~\*\/)", string)
                            if blockmatch:
                                anonymous_block = anonymous_block + 1
                                totaltypecountmap["ANONYMOUS BLOCK"] = anonymous_block
                fl.close()


def gettypecountbulk(homepath):
    filename = os.path.join(homepath, 'log', 'gaussexecutionlog.log')
    if os.path.exists(filename):
        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(createtable, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[createtable] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(altertable, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[altertable] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(createtype, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[createtype] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(altertype, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[altertype] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(createindex, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[createindex] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(alterindex, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[alterindex] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(createsequence, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[createsequence] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(altersequence, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[altersequence] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(createsession, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[createsession] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(altersession, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[altersession] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(createsynonym, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[createsynonym] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(altersynonym, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[altersynonym] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(createview, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[createview] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(alterview, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[alterview] = output

        cmd = 'grep -w \"COMMENT\\$\" {0}|wc -l'.format(filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap["COMMENT"] = output

        cmd = 'grep -E \"^INSERT\\s[0-9]+\\s[0-9]+$\" {0}|wc -l'.format(filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap["INSERT"] = output

        cmd = 'grep -E \"^DELETE\\s[0-9]+\" {0}|wc -l'.format(filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap["DELETE"] = output

        cmd = 'grep -E \"^UPDATE\\s[0-9]+\" {0}|wc -l'.format(filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap["UPDATE"] = output

        cmd = 'grep -E \"^TRUNCATE\\sTABLE\" {0}|wc -l'.format(filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap["TRUNCATE"] = output


def gettypecountblogic(homepath):
    filename = os.path.join(homepath, 'log', 'gaussexecutionlog.log')
    if os.path.exists(filename):
        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(createfunction, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[createfunction] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(createprocedure, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[createprocedure] = output

        cmd = 'grep -w \"{0}\\$\" {1}|wc -l'.format(createpackage, filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[createpackage] = output

        cmd = 'grep -E \"^ANONYMOUS\\sBLOCK\" {0}|wc -l'.format(filename)
        status, output = getstatusoutput(cmd)
        successtypecountmap[anonymousblock] = output


def writeandprintoutput(homepath):
    header = ['Statement', 'Total', 'Success', 'Failed']
    rows = list()
    filename = os.path.join(homepath, 'log', 'statement_result.csv')
    with open(filename, 'w') as csvfile:
        try:
            csvwriter = csv.writer(csvfile)
            csvwriter.writerow(header)
            for key, value in totaltypecountmap.items():
                if value != 0:
                    data = successtypecountmap.get(key)
                    if data is not None:
                        if data.isdigit():
                            successvalue = int(data)
                        else:
                            successvalue = 0
                        if successvalue > value:
                            successvalue = value
                    else:
                        successvalue = 0
                    rows.append([key, value, successvalue, value - successvalue])
            csvwriter.writerows(rows)
        except IOError as error:
            logging.error("Exception occured during writing to csv file {0}".
                          format(error))
        finally:
            csvfile.close()
    if len(totaltypecountmap) == 0:
        return
    print "\nSummary of Verification : "
    print('\n========================================================================================================'
          '====\n')
    print('{0:<25}| {1:<20}| {2:<20}| {3:<20}| {4:<20}\n'.format('Statement', 'Total', 'Passed', 'Failed',
                                                                 'Success Rate(%)'))
    print(
        '------------------------------------------------------------------------------------------------------------\n')
    totalquery = 0
    totalsuccess = 0
    for key, value in totaltypecountmap.items():
        if value != 0:
            data = successtypecountmap.get(key)
            if data is not None:
                if data.isdigit():
                    successvalue = int(data)
                else:
                    successvalue = 0

                if successvalue > value:
                    successvalue = value
            else:
                successvalue = 0
            totalquery = totalquery + value
            totalsuccess = totalsuccess + successvalue
            print('{0:<25}| {1:<20}| {2:<20}| {3:<20}| {4:<20}\n'.format(key, value, successvalue, value - successvalue,
                                                                         (successvalue * 100) / value))
    print(
        '------------------------------------------------------------------------------------------------------------\n')
    print('{0:<25}| {1:<20}| {2:<20}| {3:<20}| {4:<20}\n'.format('Total', totalquery, totalsuccess,
                                                                 totalquery - totalsuccess,
                                                                 (totalsuccess * 100) / totalquery))
    print(
        '============================================================================================================\n')


def writeandprintoutputDBT(outputfol, homepath):

    totaldbtquery = totalDBTquery()
    faileddbtquery = failedDBTquery()

    header = ['Statement', 'Total', 'Success', 'Failed']
    rows = list()
    filename = os.path.join(homepath, 'log', 'statement_result.csv')
    with open(filename, 'w') as csvfile:
        try:
            csvwriter = csv.writer(csvfile)
            csvwriter.writerow(header)
            if faileddbtquery > totaldbtquery:
                faileddbtquery = totaldbtquery
            rows.append(['Total', totaldbtquery, totaldbtquery-faileddbtquery, faileddbtquery])
            csvwriter.writerows(rows)
        except IOError as error:
            logging.error("Exception occured during writing to csv file {0}".
                          format(error))
        finally:
            csvfile.close()
    if totaldbtquery == 0:
        return
    print "\nSummary of Verification : "
    print('\n========================================================================================================'
          '====\n')
    print('{0:<25}| {1:<20}| {2:<20}| {3:<20}| {4:<20}\n'.format('Statement', 'Total', 'Passed', 'Failed',
                                                                 'Success Rate(%)'))
    print(
        '------------------------------------------------------------------------------------------------------------\n')
    print('{0:<25}| {1:<20}| {2:<20}| {3:<20}| {4:<20}\n'.format('Total', totaldbtquery,totaldbtquery -faileddbtquery,faileddbtquery
                                                                 ,
                                                                 ((totaldbtquery -faileddbtquery) * 100) / totaldbtquery))
    print(
        '============================================================================================================\n')
