import logging
import subprocess
from shlex import split

current_query_count = 0
total_query = 0
failed_query = 0


def execute_script(cmd):
    """Execute the given command and write to file"""
    args = split_command(cmd)
    try:
        process = subprocess.Popen(args, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        output, unused_err = process.communicate()
        return process.poll(), unused_err or output
    except (OSError, IOError, Exception) as error:
        logging.error(error)
        return 1, str(error.strerror)


def execute_script_write(cmd, outputfilename, file_name, errorlogfile):
    """Execute the given command and write to file"""
    args = split_command(cmd)
    filename = open(outputfilename, "a")
    errorfilename = open(errorlogfile, "a")
    global current_query_count
    try:
        process = subprocess.Popen(args, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        output, unused_err = process.communicate()
        filename.writelines(file_name)
        filename.writelines('\n')
        filename.writelines(output)
        if unused_err is not None:
            if 'error' in unused_err or 'ERROR' in unused_err:
                filename.writelines(unused_err)
                errorfilename.writelines('Compiling the file ')
                errorfilename.writelines(file_name)
                errorfilename.writelines('\n')
                errorfilename.writelines(unused_err)
        current_query_count = current_query_count + 1
        return process.poll(), unused_err or output
    except (OSError, IOError, Exception) as error:
        current_query_count = current_query_count + 1
        logging.error(error)
        return 1, str(error.strerror)
    finally:
        filename.close()
        errorfilename.close()


def execute_script_write_T(cmd, outputfilename, errorlogfile, file_name, line_number, flag):
    """Execute the given command and write to file"""
    args = split_command(cmd)
    filename = open(outputfilename, "a")
    errorfilename = open(errorlogfile, "a")
    global total_query
    global failed_query
    try:
        process = subprocess.Popen(args, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        output, unused_err = process.communicate()
        if flag == True:
            filename.writelines("Compiling the file ")
            filename.writelines(file_name)
            filename.writelines('\n')
        if 'GS-' in output or 'error' in output:
            errorlines = output.split('\n')
            errorfilename.writelines('\n')
            errorfilename.writelines(file_name)
            filename.writelines(file_name)
            filename.writelines('\n')
            for lne in errorlines:
                if len(lne) > 0 and lne[0] == '[':
                    value = lne[1:lne.find(':')]
                    if value.isdigit:
                        string = int(value) + line_number -1
                        lne = lne.replace(value, str(string))
                        errorfilename.writelines(lne)
                        filename.writelines(lne)
                    else:
                        errorfilename.writelines(lne)
                        filename.writelines(lne)
                else:
                    errorfilename.writelines(lne)
                    filename.writelines(lne)
                filename.writelines('\n')
                errorfilename.writelines('\n')
            #filename.writelines(file_name)
            failed_query = failed_query + 1

        else:
            filename.writelines(output)
        if unused_err is not None:
            if 'error' in unused_err or 'ERROR' in unused_err:
                filename.writelines(unused_err)
                errorfilename.writelines(unused_err)
        total_query = total_query + 1
        return process.poll(), unused_err or output
    except (OSError, IOError, Exception) as error:
        total_query = total_query + 1
        logging.error(error)
        return 1, str(error.strerror)
    finally:
        filename.close()
        errorfilename.close()


def totalDBTquery():
    return total_query


def failedDBTquery():
    return failed_query


def split_command(cmd):
    """Split command for subprocess execution"""
    if isinstance(cmd, unicode):
        cmd = cmd.encode("utf-8")
    return split(cmd)


def getqueycount():
    return current_query_count


def setquerycount(value):
    global current_query_count
    current_query_count = value
